
function monstr, month
  if month lt 10 then begin
    month_str = '0'+strtrim(string(month),1)
  endif else begin
    month_str = strtrim(string(month),1)
  endelse
  return,month_str
end

pro Partial_correlation_analysis
  outpath = 'D:\output\'
  query_status = query_tiff('D:\input\reference.tif',infor,geotiff=geoinfor)  ;输出tiff的参考文件
  VAR_temp = read_tiff('D:\input\reference.tif')
  VAR_size = size(VAR_temp,/DIMENSIONS)
  NC = VAR_size[0]
  NR = VAR_size[1]
  DELVAR, VAR_temp
  num_file_VAR = 29

  TMP_path = 'D:\input\climate\tmp'
  CLD_path = 'D:\input\climate\cld'
  PRE_path = 'D:\input\climate\pre'
  PHE_path = 'D:\input\GUD\GUD'
  VAR_path = 'D:\input\SOT\SOT'
  VAR2_path = 'D:\input\ALT\ALT'

  phe_TOTAL = fltarr(num_file_VAR, NC, NR)
  tmp_TOTAL = fltarr(num_file_VAR, NC, NR)
  cld_TOTAL = fltarr(num_file_VAR, NC, NR)
  pre_TOTAL = fltarr(num_file_VAR, NC, NR)
  var_TOTAL = fltarr(num_file_VAR, NC, NR)
  var2_TOTAL = fltarr(num_file_VAR, NC, NR)
  par_TMP_GUD = fltarr(NC, NR)
  par_TMP_GUD_ctrl = fltarr(NC, NR)
  for year = 0,num_file_VAR-1 do begin
    print, year+1987
    year_str =strtrim(string(year+1987),1)
    phe_t = read_tiff(strjoin(PHE_path+year_str+'.tif'))
    phe_TOTAL[year,*,*] = phe_t
    tmp_t = read_tiff(strjoin(TMP_path+year_str+'.tif'))
    tmp_TOTAL[year,*,*] = tmp_t
    cld_t = read_tiff(strjoin(CLD_path+year_str+'.tif'))
    cld_TOTAL[year,*,*] = cld_t
    pre_t = read_tiff(strjoin(PRE_path+year_str+'.tif'))
    pre_TOTAL[year,*,*] = pre_t
    var_t = read_tiff(strjoin(VAR_path+year_str+'.tif'))
    var_TOTAL[year,*,*] = var_t
    var2_t = read_tiff(strjoin(VAR2_path+year_str+'.tif'))
    var2_TOTAL[year,*,*] = var2_t
  endfor

  for line=0, NR-1 do begin
    for column=0, NC-1 do begin
      tmpvec = tmp_TOTAL[*,column,line]
      cldvec = cld_TOTAL[*,column,line]
      prevec = pre_TOTAL[*,column,line]
      phevec = phe_TOTAL[*,column,line]
      varvec = var_TOTAL[*,column,line]
      var2vec = var2_TOTAL[*,column,line]
      if ((ABS(mean(phevec)) GT 1000)||(ABS(mean(tmpvec)) GT 100)) then begin
        par_TMP_GUD[column,line] = -2
        par_TMP_GUD_ctrl[column,line] = -2
        continue
      endif
      par_TMP_GUD[column,line] = p_correlate(phevec,tmpvec,[transpose(cldvec),transpose(prevec)])
      par_TMP_GUD_ctrl[column,line] = p_correlate(phevec,tmpvec,[transpose(cldvec),transpose(prevec),transpose(varvec),transpose(var2vec)])
    endfor
  endfor


  par_phe_var_f = outpath+'par_TMP_GUD.tif'
  write_tiff,par_phe_var_f,par_TMP_GUD,/float,geotiff=geoinfor
  print,par_phe_var_f+' is finished!'

  par_phe_var2_f = outpath+'par_TMP_GUD_ctrlT.tif'
  write_tiff,par_phe_var2_f,par_TMP_GUD_ctrl,/float,geotiff=geoinfor
  print,par_phe_var2_f+' is finished!'

end